/* ------------------
 * ThinkMIMI TIM
 * --------------- */

$(document).ready(function(){
    // 禁止火狐浏览器使用即时通讯功能
    if(navigator.userAgent.indexOf("Firefox")>0){  
        $('.mimi_tim_fixed').hide();
    } 
    /**
     * 消息数+1
    */
    mimi_add_dope = function(){
        var num = $('.mimi_tim_dope').html();
        if (num != '') {
            num = parseInt(num)+1;
        } else {
            num = 1;
        }
        $('.mimi_tim_dope').html(num);
    }

    /**
     * 消息数-1
    */
    mimi_delete_dope = function(){
        var num = $('.mimi_tim_dope').html();
        num = parseInt(num);
        if (num != '' && num > 1) {
            num = num-1;
        } else {
            num = '';
        }
        $('.mimi_tim_dope').html(num);
    }

    /**
     * 播放音频
    */
    mimi_mp4 = function(){
        // 打开音频提示音
        var player = $("#mimi_player_1")[0];
        player.play();
    }
    /**
     * 获得字节数
    */
    getBt = function(str){
        var char = str.match(/[^\x00-\xff]/ig);
        return str.length + (char == null ? 0 : char.length);
    }
    /**
     * 阻止冒泡
    */
    preventBubble = function(event){
        var e=arguments.callee.caller.arguments[0]||event; //若省略此句，下面的e改为event，IE运行可以，但是其他浏览器就不兼容
        if (e && e.stopPropagation) {
            e.stopPropagation();
        } else if (window.event) {
            window.event.cancelBubble = true;
        }
    }

    /**
     * 获取当前时间
    */
    get_time = function(){
        var date = new Date();
        var year = date.getFullYear();
        var month = date.getMonth()+1;
        var day = date.getDate();
        var hour = date.getHours();
        var minute = date.getMinutes();
        var second = date.getSeconds();
        return year+'-'+month+'-'+day+' '+hour+':'+minute+':'+second;
    }

    /**
     * 组装Socket聊天所需要的HTML结构
    */
    mimi_html = function(img, title, txt, _class){
        var html = '';
        html += '<li class="'+_class+'">';
        html += '<div class="mimi_tim_chat_user">';
        html += '<img src="'+img+'">';
        if (_class != '') {
            html += '<cite><i>'+get_time()+'</i>'+title+'</cite>';
        } else {
            html += '<cite>'+title+'<i>'+get_time()+'</i></cite>';
        }
        html += '</div>';
        html += '<div class="mimi_tim_chat_text">'+txt+'</div>';
        html += '</li>';
        return html;
    }
    // 只有登录后的，才会联线Socket
    if ($('div').hasClass('mimi_tim_head') && navigator.userAgent.indexOf("Firefox") < 0){
        var lockReconnect = false;//避免重复连接
        // 你的server地址
        var wsUrl = 'ws:/127.0.0.1';
        var ws;
        var tt;
        createWebSocket();
        // ①开启WebSocket
        function createWebSocket() {
            try {
                ws = new WebSocket(wsUrl);
                init();
            } catch(e) {
                reconnect(wsUrl);
            }
        }
        // ②初始化WebSocket，并设置心跳检测
        function init() {
            // 接收Socket断开时的消息通知
            ws.onclose = function(){
                console.log("断开socket连接了。。。试图重新连接。。。。");
                jApp.dialog('Socket断开了...正在试图重新连接...', 'error');
                reconnect(wsUrl);
            };
            // 接收Socket连接失败时的异常通知
            ws.onerror = function(e){
                console.log("ERROR:" + e.data);
                jApp.dialog('Socket断开了...正在试图重新连接...', 'error');
                reconnect(wsUrl);
            };
            // 连接成功
            ws.onopen = function () {
                console.log("握手成功，打开socket连接了。。。");
                jApp.dialog('WebSocket连接成功！');
                //心跳检测重置
                heartCheck.start();
            };


            var message = '';
            var flag    = true;
            // 接收服务端广播的消息通知
            ws.onmessage = function(e){
                heartCheck.start();
                if (e.data == '123456789') { return false;}
                message += e.data;
                try {
                    obj = JSON.parse(e.data); 
                } catch(error_1) {
                    try {
                        obj = JSON.parse(message); 
                        flag = true;
                    } catch (error_2) {
                        flag = false;
                    }
                }

                if (flag !== false) {
                    console.log(message);
                    message = '';
                    // 群聊
                    if (obj.type == 1) {
                        var html = mimi_html(obj.img, obj.title, obj.txt, '');
                    } else if (obj.type == 2) {
                    // 私聊
                        var html = mimi_html(obj.img, obj.title, obj.txt, '');
                    } else if (obj.type == 3) {
                    // 进群广播
                        var html  = '';
                        html += '<li class="mimi_tim_chat_system">';
                        html += '<span>'+obj.title+' 骑着宝马 进入该群</span>';
                        html += '</li>';
                    } else if(obj.type == 4) {
                    // 消息通知
                        var id  = $('.mimi_tim_head').attr('data-id');
                        // 自查一下是不是自己的消息
                        if (obj.id == id) {
                            mimi_add_dope();
                            mimi_mp4();
                        }
                    }
                    
                    // 有前端框架样式，就是聊天内容广播
                    if (obj._class != '') {
                        // 私聊要做身份自核验证
                        if (obj.type == 2) {
                            var is = $('.'+obj._class).html();
                            // 框口存在
                            if (is) {
                                // 推送到对应的聊天窗口上
                                $('.'+obj._class).find('.mimi_tim_chat').append(html);
                                mimi_mp4();
                            } else {
                            // 不存在要创建框口并弹出
                                $(".mimi_tim_open").each(function(){
                                    var type = $(this).attr('data-type');
                                    var pid  = $(this).attr('data-pid');
                                    if (type == 2 && pid == obj.pid) {
                                        $(this).click();
                                        // 推送到对应的聊天窗口上
                                        $('.'+obj._class).find('.mimi_tim_chat').append(html);
                                        mimi_mp4();
                                        return false;
                                    }
                                });
                            }
                        } else {
                            // 推送到对应的聊天窗口上
                            $('.'+obj._class).find('.mimi_tim_chat').append(html);
                            mimi_mp4();
                        }
                        
                        // 自动滑到底部
                        $(document).ready(function(){
                            $('.'+obj._class).find('.mimi_tim_chat').scrollTop(20000);
                        });
                    }
                }
            };
        }
        // ③ 掉线重连
        function reconnect(url) {
            if(lockReconnect) {
                return;
            };
            lockReconnect = true;
            //没连接上会一直重连，设置延迟避免请求过多
            tt && clearTimeout(tt);
            tt = setTimeout(function () {
                createWebSocket(url);
                lockReconnect = false;
            }, 4000);
        }
        // ④心跳检测
        var heartCheck = {
            timeout: 3000,
            timeoutObj: null,
            serverTimeoutObj: null,
            start: function(){
                var self = this;
                this.timeoutObj && clearTimeout(this.timeoutObj);
                this.serverTimeoutObj && clearTimeout(this.serverTimeoutObj);
                this.timeoutObj = setTimeout(function(){
                //这里发送一个心跳，后端收到后，返回一个心跳消息，
                //onmessage拿到返回的心跳就说明连接正常
                ws.send("123456789");
                //self.serverTimeoutObj = setTimeout(function() {
                    //ws.close();
                    // createWebSocket();
                //}, self.timeout);

                }, this.timeout)
            }
        }
        /**
         * 进群时广播通知
        */
        mimi_qun_guangbo = function(_class) {
            var title = $('.mimi_time_txt>ul>li:nth-child(1)').html(); // 获取用户昵称
            // 推送信息给Socket
            var data = {'_class':_class, 'title':title, 'type':'3'};
            data = JSON.stringify(data);
            ws.send(data);
        }

        
        
        /**
         * 点击发送，发送Socket请求
         * @param pid  私聊身份凭证
         * @param type 分类 1|2 群聊，私聊
         * @param id   群ID，私人ID
         * @param _class 前端框口编码
        */
        mimi_socket = function (pid, type, id, _class) {
            var txt  = $('.'+_class).find('textarea').val(); // 获取输入内容
            if (txt == '') {
                return false;
            }
            var img  = $('.mimi_tim_head').attr('data-img'); // 获取头像地址
            var title = $('.mimi_time_txt>ul>li:nth-child(1)').html(); // 获取用户昵称
            // 推送信息给Socket
            if (type ==1) {
                var data = {'id':id, '_class':_class, 'img':img, 'title':title, 'txt':txt, 'type':type};
            } else {
                var data = {'id':id, '_class':_class, 'img':img, 'title':title, 'txt':txt, 'type':type, 'pid':pid};
            }
            
            data = JSON.stringify(data);
            if (getBt(data) > 1400) {
                jApp.dialog('你只能发送不大于1400字节的内容。', 'error'); 
                return false;
            }

            var html = mimi_html(img, title, txt, 'mimi_tim_chat_mine');
            // 先自己显示到聊天窗口上
            $('.'+_class).find('.mimi_tim_chat').append(html);
            $('.'+_class).find('textarea').val('');
            ws.send(data);
            // 自动滑到底部
            $(document).ready(function(){
                $('.'+_class).find('.mimi_tim_chat').scrollTop(20000);
            });
        }

        // 弹出添加好友弹窗，发送Socket请求
        mimi_tim_qq = function(id, _this) {
            var is = $(_this).html();
            if (is == '添加基友') {
                var __this = $(_this).parent().parent().parent().parent().parent().parent().parent().parent();
                $(this).html('提交中..');
                var data = {'id':id};
                $.ajax({
		            type: 'post',
		            data: data,
                    url: "/socket_add_qq.jsp",
		            success: function(data) {
                        $(_this).html('添加基友');
                        var array = eval('('+data+')');
                        if (array['code'] == '01') {
                            jApp.dialog(array['msg'], 'error'); 
                        } else {
                            jApp.dialog(array['msg']); 
                            // 推送给对应好友
                            var data = {'id':id, 'type':4};
                            data = JSON.stringify(data);
                            ws.send(data);
                            $(__this).animate({width:"0px"});
                            window.setTimeout(function(){ 
                                $(__this).remove();
                            }, 100);
                        }
                    }
		        });
            } else {
                jApp.dialog('提交中请，请稍等~', 'error');return false;
            }
        }
        // 通过好友申请
        mimi_apply_ok = function(id, _this){
            var __this = $(_this).parent().parent().parent().parent().parent();
            var is = $(_this).html();
            if (is == '同意') {
                jApp.dialog('系统处理中...'); 
                $(_this).html('提交中..');
                var data = {'id':id};
                $.ajax({
		            type: 'post',
		            data: data,
                    url: "/socket_apply_ok.jsp",
		            success: function(data) {
                        var array = eval('('+data+')');
                        if (array['code'] == '01') {
                            $(_this).html('同意');
                            jApp.dialog(array['msg'], 'error'); 
                        } else {
                            jApp.dialog(array['msg']); 
                            // 推送给对应好友
                            var data = {'id':array['data'], 'type':4};
                            data = JSON.stringify(data);
                            ws.send(data);
                            // 关闭弹窗
                            $(__this).animate({width:"0px"});
                            window.setTimeout(function(){ 
                                $(__this).remove();
                            }, 100);
                            // 消息数-1
                            mimi_delete_dope();
                        }
                    }
		        });
            } else {
                jApp.dialog('提交中请，请稍等~', 'error');return false;
            }
        }
        // 拒绝好友申请
        mimi_apply_no = function(id, _this){
            var __this = $(_this).parent().parent().parent().parent().parent();
            var is = $(_this).html();
            if (is == '拒绝') {
                jApp.dialog('系统处理中...'); 
                $(_this).html('提交中..');
                var data = {'id':id};
                $.ajax({
		            type: 'post',
		            data: data,
                    url: "/socket_apply_no.jsp",
		            success: function(data) {
                        var array = eval('('+data+')');
                        if (array['code'] == '01') {
                            $(_this).html('拒绝');
                            jApp.dialog(array['msg'], 'error'); 
                        } else {
                            jApp.dialog(array['msg']); 
                            // 推送给对应好友
                            var data = {'id':array['data'], 'type':4};
                            data = JSON.stringify(data);
                            ws.send(data);
                            // 关闭弹窗
                            $(__this).animate({width:"0px"});
                            window.setTimeout(function(){ 
                                $(__this).remove();
                            }, 100);
                            // 消息数-1
                            mimi_delete_dope();
                        }
                    }
		        });
            } else {
                jApp.dialog('提交中请，请稍等~', 'error');return false;
            }
        }
    }

    // 普通弹窗函数
    tim_alert = function(title, main, width, height) {
        // 兼容浏览器宽度
        var h = window.innerHeight;
        var w = window.innerWidth;
        // 初始化PC端适配
        var left = width / 2;
        var top  = height / 2;
        var css  = 'style="width:'+width+'px; margin-left: -'+left+'px; height: '+height+'px; margin-top: -'+top+'px"';
        // 移动设备
        if (w <= 414 && width > w) {
            if (height > h) {
                height = h;
                top  = h / 2;
            }
            var css  = 'style="left:0px;width:'+w+'px; margin-left: 0px; height: '+height+'px; margin-top:-'+top+'px";';
        }

        // 添加弹窗
        var html = '<div '+css+' class="mimi_tim_alert"><div class="mimi_tim_alert_top"><span>'+title+'</span><span class="mimi_tim_alert_out">×</span></div><div class="mimi_tim_alert_main">'+main+'</div></div>';
        $('body').append(html);
        // 关闭普通弹窗
        $('.mimi_tim_alert_out').on('click', function(){
            var _this = $(this).parent().parent();
            $(_this).animate({width:"0px"});
            window.setTimeout(function(){ 
                $(_this).remove();
            }, 100); 
        });
        // 点击皮肤更换
        $('.mimi_tim_alert_main li img').on('click', function(){
            var img = $(this).attr('src');
            $('.mimi_tim').css('background-image', 'url('+img+')');
            $('.mimi_tim_head .mimi_time_txt li:nth-child(1)').css('color', '#fff');
        });
        // 点击创建分组
        $('#ok_grouping').on('click', function(){
            return false;
            var _this = $(this).parent().parent();
            var is    = $(this).html();

            if (is == '创建') {
                $(this).html('提交中..');
                var name = $('#grouping').val();
                var data = {'name':name};
                _this    = $(this);
                $.ajax({
		            type: 'post',
		            data: data,
                    url: "/socket_add_grouping.jsp",
		            success: function(data) {
                        $(_this).html('创建');
                        var array = eval('('+data+')');
                        if (array['code'] == '01') {
                            jApp.dialog(array['msg'], 'error'); 
                        } else {
                            jApp.dialog(array['msg']); 
                            $(_this).animate({width:"0px"});
                            window.setTimeout(function(){ 
                                $(_this).remove();
                                window.location.reload();
                            }, 100);
                        }
                    }
		        });
            } else {
                jApp.dialog('提交中请，请稍等~', 'error');return false;
            }
        });
        // 点击按钮切换加人搜索
        $('.mimi_add_qun>a').on('click', function(){
            $('.mimi_add_qun>a').removeClass('mimi_qun_l');
            $(this).addClass('mimi_qun_l');
            _this   = $(this).parent().parent().parent();
            var type = $(this).attr('data-type');
            // 兼容浏览器宽度
            var h = window.innerHeight;
            var w = window.innerWidth;
            if (type == 1) {
                // 移动设备
                if (w <= 414) {
                    $( _this).css({'width':w+'px', 'margin-left':'0px', 'height':'200px', 'margin-top':'-100px', 'left':'0px', 'top':'50%'});
                } else {
                    $( _this).css({'width':'400px', 'margin-left':'-200px', 'height':'200px', 'margin-top':'-100px'});
                }
                $('#mimi_qun_2').hide();
            } else {
                // 移动设备
                if (w <= 414) {
                    $( _this).css({'width':w+'px', 'margin-left':'0px', 'height':h+'px', 'margin-top':'0px', 'left':'0px', 'top':'0px'});
                    $('#mimi_qun_2').css('height', (h-74)+'px');
                } else {
                    $( _this).css({'width':'400px', 'margin-left':'-200px', 'height':'440px', 'margin-top':'-220px'});
                }
                
                $('#mimi_qun_1').hide();
                $.ajax({
		            type: 'post',
                    data: {},
                    url: "/socket_select_qun.jsp",
		            success: function(data) {
                        var array = eval('('+data+')');
                        if (array['code'] == '01') {
                            jApp.dialog(array['msg'], 'error'); 
                        } else {
                            jApp.dialog(array['msg']); 
                            var html = '<ul>';
                            var arr  = array['data']
                            for(var i=0; i<arr.length; i++){
                                html += "<li>";
                                html += "<div><img src='"+arr[i]['img']+"'><p>"+arr[i]['name']+"</p><p>人数："+arr[i]['num']+"/"+arr[i]['max']+"</p><p>"+arr[i]['position']+"</p></div>";
                                html += "<div>"+arr[i]['des']+"</div>";
                                html += "<div><a data-id='"+arr[i]['id']+"' class='mimi_btu' onClick='mimi_add_jiaqun(this)'>加入群聊</a></div>";
                                html += "</li>";
                            }
                            html +='</ul>';
                            $('#mimi_qun_'+type).html(html);
                        }
                    }
		        });
            }
            $('#mimi_qun_'+type).show();
        });
        // 申请加群
        mimi_add_jiaqun = function(obj){
            var __this = $(obj).parent().parent().parent();
            var id     = $(obj).attr('data-id');
            var is     = $(obj).html();

            if (is == '加入群聊') {
                $(obj).html('提交中..');
                var data = {'id':id};
                _this    = $(obj);
                $.ajax({
		            type: 'post',
		            data: data,
                    url: "/socket_add_jiaqun.jsp",
		            success: function(data) {
                        $(_this).html('加入群聊');
                        var array = eval('('+data+')');
                        if (array['code'] == '01') {
                            jApp.dialog(array['msg'], 'error'); 
                        } else {
                            jApp.dialog(array['msg']); 
                            $(_this).animate({width:"0px"});
                            window.setTimeout(function(){ 
                                $(__this).remove();
                                window.location.reload();
                            }, 100);
                        }
                    }
		        });
            } else {
                jApp.dialog('提交中请，请稍等~', 'error');return false;
            }
        }
        // 点击搜索博客基友
        $('#s_niuniu').on('click', function(){
            __this   = $(this).parent().parent().parent();
            var is   = $(this).html();

            if (is == '搜索') {
                $(this).html('提交中..');
                var name = $('#niuniu').val();
                var data = {'name':name};
                _this    = $(this);
                $.ajax({
		            type: 'post',
		            data: data,
                    url: "/socket_select_jiyou.jsp",
		            success: function(data) {
                        $(_this).html('搜索');
                        var array = eval('('+data+')');
                        var _obj  = $(_this).parent().find('.mimi_qun_list');
                        // 兼容浏览器宽度
                        var h = window.innerHeight;
                        var w = window.innerWidth;
                            
                        if (array['code'] == '01') {
                            jApp.dialog(array['msg'], 'error'); 
                            // 移动设备
                            if (w <= 414) {
                                $(__this).css({'width':w+'px', 'margin-left':'0px', 'height':'200px', 'margin-top':'-100px', 'left':'0px', 'top':'50%'});
                            } else {
                                $(__this).css({'width':'400px', 'margin-left':'-200px', 'height':'200px', 'margin-top':'-100px'});
                            }
                            $(_obj).hide();
                        } else {
                            jApp.dialog(array['msg']); 
                            // 移动设备
                            if (w <= 414) {
                                $(__this).css({'width':w+'px', 'margin-left':'0px', 'height':h+'px', 'margin-top':'0px', 'left':'0px', 'top':'0px'});
                                $('.mimi_qun_list').css('height','330px');
                            } else {
                                $(__this).css({'width':'400px', 'margin-left':'-200px', 'height':'400px', 'margin-top':'-200px'});
                                $('.mimi_qun_list').css('height','190px');
                            }
                            $(_obj).show();

                            var html = '<ul>';
                            var arr  = array['data']
                            for(var i=0; i<arr.length; i++){
                                if (arr[i]['portrait'] == null) {
                                    var img = '/public/images/portrait.jpg';
                                } else {
                                    var img = arr[i]['portrait'];
                                }
                                if (arr[i]['title'] == null) {
                                    var title = '';
                                } else {
                                    var title = '【'+arr[i]['title']+'】';
                                }
                                html += "<li>";
                                html += "<div><img src='"+img+"'><p>"+arr[i]['name']+title+"</p><p><a class='mimi_btu' onClick='mimi_tim_qq("+arr[i]['id']+", this)'>添加基友</a></p></div>";
                                html += "</li>";
                            }
                            html +='</ul>';
                            $(_obj).html(html);
                        }
                    }
		        });
            } else {
                jApp.dialog('提交中请，请稍等~', 'error');return false;
            }
        });
    }
    // 点击加人
    $('#mimi_tim_add').click(function(){
        if ($('.mimi_tim_add').css('display') == 'none') {
            $('.mimi_tim_add').slideDown(300);
        } else {
            $('.mimi_tim_add').slideToggle(300);
        }
    });
    // 点击加人下的菜单隐藏切换
    $('.mimi_tim_footer .mimi_tim_add li').click(function(){
        $('.mimi_tim_add').slideToggle(300);
        if ($(this).attr('data-type') == 1) {
            tim_alert('加好友/加群', '<div class="mimi_add_qun"><a data-type="1" class="mimi_qun_l">加好友</a><a data-type="2">官方群</a></div><div id="mimi_qun_1"><input class="mimi_input" type="text" id="niuniu" placeholder="博友用户名/昵称"><br/><a class="mimi_btu" id="s_niuniu">搜索</a><br/><div class="mimi_qun_list"></div></div><div id="mimi_qun_2" class="mimi_qun_list"><div style="text-align: center;">加载中...</div></div>', 400, 200);
        } else {

            jApp.dialog('不多人用，暂时放弃这个功能','error');
            return false;
            tim_alert('新分组', '<input class="mimi_input" type="text" id="grouping" placeholder="分组名称"><br/><a class="mimi_btu" id="ok_grouping">创建</a>', 300, 140);
        }
    });
    // 点击打开MIMI
    $(".mimi_tim_fixed").click(function(){
        $(this).animate({bottom:"-30"});
        window.setTimeout(function(){ 
            $('.mimi_tim').animate({bottom:"0"}, 0);
        }, 100); 
    });
    // 点击关闭MIMI
    $(".mimi_tim_out").click(function(){
        $('.mimi_tim').animate({bottom:"-520"});
        window.setTimeout(function(){ 
            $('.mimi_tim_fixed').animate({bottom:"0"}, 0);
        }, 100); 
    });
    // 点击换肤
    $("#mimi_tim_skin").click(function(){
        tim_alert('换肤', '<ul><li><img src="/public/mimi_tim/skin_1.jpg"></li><li><img src="/public/mimi_tim/skin_2.jpg"></li><li><img src="/public/mimi_tim/skin_3.jpg"></li></ul>', 300, 110);
    });
    // 点击关于MIMI
    $("#mimi_tim_about").click(function(){
        tim_alert('关于MIMI', '<ul><li style="width:100%">版本：v1.0.1</li><li style="width:100%">版权所有：blog.junphp.com</li><li style="width:100%">前端驱动：CSS3+Jquery+WebCocket</li><li style="width:100%">后端驱动：PHP7+Socket+ThinkMIMI</li></ul>', 300, 200);
    });
    // 点击切换菜单
    $('.mimi_tim_main_top li').click(function(){
        var type=$(this).attr('data-type');
        $('.mimi_tim_main_top li').removeClass('mimi_high');
        $(this).addClass('mimi_high');
        $('.mimi_tim_main_content>div').removeClass('mimi_high');
        $('.mimi_tim_main_content>div:nth('+type+')').addClass('mimi_high');
    })
	// 菜单中点击显示下拉二级
	$('.mimi_tim_main_content>.mimi_high>ul').on('click', function(){
		// 显示菜单
        var _this = $(this).find('ul');
		if ($(_this).css('display') == 'none') {
			$(_this).slideDown(500);
		} else {
			$(_this).slideToggle(500);
		}
        // 旋转箭头
        var _this = $(this).find('li').find('span').find('img');
        if($(_this).hasClass("rotate")){ //点击箭头旋转180度
            $(_this).removeClass("rotate");
            $(_this).addClass("rotate1");
        }else{
            $(_this).removeClass("rotate1"); //再次点击箭头回来
            $(_this).addClass("rotate");
        }
	});
    // 组装聊天HTML框架
    mimi_tim_open_content = function(type, id, img, title, _class, pid){
        var html = '';
        html += '<div class="mimi_tim_popup '+_class+'">';
        html += '<div class="mimi_tim_title">';
        html += '<img src="'+img+'">';
        html += '<span class="mimi_qun">'+title+'</span>';
        html += '<span class="mimi_tx">';
        html += '<a class="mimi_min" href="javascript:;" onClick="mimi_close()"></a>';
        html += '<a class="mimi_max" href="javascript:;" onClick="mimi_max()"></a>';
        html += '<a class="mimi_close" href="javascript:;" onClick="mimi_close()"></a>';
        html += '</span>';
        html += '</div>';
        html += '<div class="mimi_tim_chat">';
        html += '</div>';
        html += '<div class="mimi_tim_chat_footer">';
        html += '<div class="mimi_tim_emoji"></div>';
        html += '<div class="mimi_tim_textarea">';
        html += '<textarea oninput=mimi_propertychange(this)></textarea>';
        html += '</div>';
        html += '<div class="mimi_tim_chat_bottom">';
        html += '<div class="mimi_tim_chat_send">';
        html += "<span class='mimi_input_textarea'></span>";
        if (pid) {
            html += "<span class='mimi_tim_chat_send_btn' onClick=mimi_socket("+pid+","+type+","+id+",'"+_class+"')>发送</span>";
        } else {
            html += "<span class='mimi_tim_chat_send_btn' onClick=mimi_socket(0,"+type+","+id+",'"+_class+"')>发送</span>";
        }
        html += "<span onClick=mimi_nav_tab_out('"+_class+"')>关闭</span>";
        html += '</div>';
        html += '</div>';
        html += '</div>';
        html += '</div>';
        return html;
    }
    // 输入框输入时监听输入长度
    mimi_propertychange = function(_this){
        var txt  = $(_this).val();
        var len  = getBt(txt);
        var num  = 1200 - len;
        if (num < 0) {
            txt = txt.substring(0, txt.length-1);
            $(_this).val(txt);
            return false;
        }
        var html = '还可以输入 '+num+' 个字节';
        $(_this).parent('.mimi_tim_textarea').next('.mimi_tim_chat_bottom').find('.mimi_tim_chat_send').find('.mimi_input_textarea').html(html);
    }


    // 点击二级菜单调用websocket弹窗
	$('.mimi_tim_open').on('click', function(){
        // 兼容浏览器宽度
        var h = window.innerHeight;
        var w = window.innerWidth;
        // 兼容移动设备
        if (w > 710) {
            $('.mimi_tim_popup_open').animate({width:"710px"}).show();
        } else {
            $('.mimi_tim_popup_open').animate({width:w+'px', 'height':h+'px', top:'0', 'left':'0'}).show();
        }

        preventBubble();

        var type   = $(this).attr('data-type');
        var id     = $(this).attr('data-id');
        var _class = 'mimi_vif_'+type+'_'+id;
        var name   = $(this).attr('data-name');
        var img    = $(this).attr('data-img');
        // 已经开启过的菜单
        if ($('#'+_class).length>0) {
            $('.mimi_tim_popup_open>ul>li').removeClass('mimi_this');
            $('.mimi_tim_content .mimi_tim_popup').hide();
            $('.'+_class).show();
            $('#'+_class).addClass('mimi_this');
        } else {
            // 先加个左侧菜单
            $('.mimi_tim_popup_open>ul>li').removeClass('mimi_this');
            $('.mimi_tim_popup_open>ul').append('<li class="mimi_this" id="'+_class+'" onClick="mimi_nav_tab(this)"><img src="'+img+'"><span>'+name+'</span><span class="mimi_tim_open_out" onClick=mimi_nav_tab_out("'+_class+'")>×</span></li>');
            // 再新建个右侧菜单
            $('mimi_tim_content').html();
            // 开启群聊天
            if (type == 1) {
                var html = mimi_tim_open_content(type, id, img, name, _class);
                // 广播进群通知
                mimi_qun_guangbo(_class);
            } else {
            // 私人聊天
                // 什么操作也不做
                var pid  = $(this).attr('data-pid');
                var html = mimi_tim_open_content(type, id, img, name, _class, pid);
            }
            $('.mimi_tim_content .mimi_tim_popup').hide();
            $('.mimi_tim_content').append(html);
        }

        // 兼容移动设备
        if (w > 710) {
            $('.mimi_tim_popup_open>ul').css('width','200px');
            $('.mimi_tim_popup_open>ul>li>span').show();
            $('.mimi_tim_popup').css('width', '500px');
            $('.mimi_tim_chat').css('height', '262px');
            $('.mimi_close').css('float','left');
            $('.mimi_min').show();
            $('.mimi_max').show();
        } else {
            $('.mimi_tim_popup_open>ul').css('width','70px');
            $('.mimi_tim_popup_open>ul>li>span').hide();
            $('.mimi_tim_popup').css('width', (w-70)+'px');
            $('.mimi_tim_chat').css('height', (h-110-178)+'px');
            $('.mimi_close').css('float','right');
            $('.mimi_min').hide();
            $('.mimi_max').hide();
        }
	});

    // 点击左侧菜单切换聊天
    mimi_nav_tab = function(_this){
        var id = $(_this).attr('id');
        $('.mimi_tim_popup_open>ul>li').removeClass('mimi_this');
        $('.mimi_tim_content .mimi_tim_popup').hide();
        $('.'+id).show();
        $('#'+id).addClass('mimi_this');
    }

    // 关闭聊天窗口
    mimi_nav_tab_out = function(_class){
        $('.mimi_tim_popup_open>ul>li').removeClass('mimi_this');
        $('.mimi_tim_content .mimi_tim_popup').hide();

        // 先查找上一个元素
        var s = $('#'+_class).prev().attr('id');
        var x = $('#'+_class).next().attr('id');
        
        if (typeof(x) != "undefined") {
            $('.'+x).show();
            $('#'+x).addClass('mimi_this');
        } else if (typeof(s) != "undefined") {
            $('.'+s).show();
            $('#'+s).addClass('mimi_this');
        } else {
            // 关闭整个弹窗
            $('.mimi_tim_popup_open').animate({width:"0px"});
            window.setTimeout(function(){ 
                $('.mimi_tim_popup_open').hide();
            }, 100); 
        }

        $('.'+_class).remove();
        $('#'+_class).remove();
        preventBubble();
    }
    // 放大缩小
    mimi_max = function(){
        var width =$('.mimi_tim_popup_open').css('width');
        if (width == '710px') {
            var h = window.innerHeight;
            var w = window.innerWidth;
            $('.mimi_tim_popup_open').css('width', w+'px');
            $('.mimi_tim_popup_open>ul').css('width', '190px');
            $('.mimi_tim_popup').css('width', (w-200)+'px');
            $('.mimi_tim_popup_open').css('height', h+'px');
            $('.mimi_tim_popup_open').css('top', '0px');
            $('.mimi_tim_popup_open').css('left', '0px');
            $('.mimi_tim_chat').css('height', (h-110-178)+'px');
        } else {
            $('.mimi_tim_popup_open').css('width', '710px');
            $('.mimi_tim_popup_open>ul').css('width', '200px');
            $('.mimi_tim_popup').css('width', '500px');
            $('.mimi_tim_chat').css('height', '262px');
            $('.mimi_tim_popup_open').css('height', '520px');
            $('.mimi_tim_popup_open').css('top', '201px');
            $('.mimi_tim_popup_open').css('left', '157.5px');
        }
    }
    // 关闭普通弹窗
    mimi_close = function(){
        $('.mimi_tim_popup_open').animate({width:"0px"});
        window.setTimeout(function(){ 
            $('.mimi_tim_popup_open').hide();
        }, 100); 
    }
    // 点击搜索按钮
    $('#mimi_tim_sou').click(function(){
        jApp.dialog('该功能暂未开放', 'error');
    })
    // 点击状态按钮
    $('#mimi_tim_status').click(function(){
        jApp.dialog('该功能暂未开放', 'error');
    })
    // 点击消息浮动块，自动触发消息按钮
    $('.mimi_tim_dope').click(function(){
        $('#mimi_tim_dope').click();
    })
    // 点击消息按钮
    $('#mimi_tim_dope').click(function(){
        jApp.dialog('请求中，请稍等~');
        $.ajax({
            type: 'post',
            data: {},
            url: "/socket_apply.jsp",
            success: function(data) {
                var array = eval('('+data+')');
                if (array['code'] == '01') {
                    jApp.dialog(array['msg'], 'error'); 
                } else {
                    jApp.dialog(array['msg']); 
                    tim_alert('消息通知', array['data'], 400, 550);
                }
            }
        });
    });

});

